From 4c246e3ca56540084395d3747acbf30ccb7d5db8 Mon Sep 17 00:00:00 2001
From: Andrey Borodin <amborodin@acm.org>
Date: Tue, 30 Oct 2018 10:50:38 +0500
Subject: [PATCH] ICU as a default collation provider rebased oct 2018

---
 doc/src/sgml/charset.sgml                     |  55 ++
 doc/src/sgml/ref/create_database.sgml         |   8 +-
 doc/src/sgml/ref/createdb.sgml                |  18 +-
 doc/src/sgml/ref/initdb.sgml                  |   9 +-
 doc/src/sgml/regress.sgml                     |  17 +
 src/backend/catalog/information_schema.sql    |   2 +-
 src/backend/commands/collationcmds.c          |  33 +-
 src/backend/commands/dbcommands.c             | 152 +++-
 src/backend/main/main.c                       |   5 +-
 src/backend/regex/regc_pg_locale.c            |  40 +-
 src/backend/utils/adt/formatting.c            | 111 ++-
 src/backend/utils/adt/like.c                  |  16 +-
 src/backend/utils/adt/pg_locale.c             | 390 ++++++---
 src/backend/utils/adt/selfuncs.c              |  14 +-
 src/backend/utils/adt/varlena.c               | 270 +++---
 src/backend/utils/init/postinit.c             | 118 ++-
 src/backend/utils/mb/encnames.c               |   4 +-
 src/bin/initdb/Makefile                       |   2 +-
 src/bin/initdb/initdb.c                       | 386 ++++++++-
 src/bin/pg_dump/pg_dump.c                     |  31 +-
 src/bin/psql/describe.c                       |  10 +-
 src/bin/scripts/Makefile                      |   2 +-
 src/bin/scripts/createdb.c                    |  14 +-
 src/common/Makefile                           |   2 +-
 src/common/pg_collation_fn_common.c           |  90 ++
 src/fe_utils/.gitignore                       |   1 +
 src/fe_utils/Makefile                         |  11 +-
 src/include/commands/dbcommands.h             |   3 +-
 src/include/common/pg_collation_fn_common.h   |  22 +
 src/include/pg_config.h.win32                 |   4 +
 src/include/port.h                            |  34 +
 src/include/port/win32.h                      |   2 +-
 src/include/utils/pg_locale.h                 |  12 +-
 src/interfaces/libpq/.gitignore               |   1 +
 src/interfaces/libpq/Makefile                 |   3 +-
 src/port/chklocale.c                          | 598 +++++++++++++
 src/test/Makefile                             |   2 +-
 src/test/default_collation/Makefile           |  28 +
 .../default_collation/icu.utf8/.gitignore     |   2 +
 src/test/default_collation/icu.utf8/Makefile  |  11 +
 .../icu.utf8/t/001_default_collation.pl       | 799 ++++++++++++++++++
 src/test/default_collation/icu/.gitignore     |   2 +
 src/test/default_collation/icu/Makefile       |  11 +
 .../icu/t/001_default_collation.pl            | 605 +++++++++++++
 .../default_collation/libc.utf8/.gitignore    |   2 +
 src/test/default_collation/libc.utf8/Makefile |  11 +
 .../libc.utf8/t/001_default_collation.pl      | 703 +++++++++++++++
 src/test/default_collation/libc/.gitignore    |   2 +
 src/test/default_collation/libc/Makefile      |  11 +
 .../libc/t/001_default_collation.pl           | 355 ++++++++
 .../regress/expected/collate.icu.utf8.out     |  10 +-
 .../regress/expected/collate.linux.utf8.out   |  10 +-
 src/test/regress/sql/collate.icu.utf8.sql     |   8 +-
 src/test/regress/sql/collate.linux.utf8.sql   |   8 +-
 src/tools/msvc/Mkvcbuild.pm                   |  22 +-
 55 files changed, 4729 insertions(+), 363 deletions(-)
 create mode 100644 src/common/pg_collation_fn_common.c
 create mode 100644 src/include/common/pg_collation_fn_common.h
 create mode 100644 src/test/default_collation/Makefile
 create mode 100644 src/test/default_collation/icu.utf8/.gitignore
 create mode 100644 src/test/default_collation/icu.utf8/Makefile
 create mode 100644 src/test/default_collation/icu.utf8/t/001_default_collation.pl
 create mode 100644 src/test/default_collation/icu/.gitignore
 create mode 100644 src/test/default_collation/icu/Makefile
 create mode 100644 src/test/default_collation/icu/t/001_default_collation.pl
 create mode 100644 src/test/default_collation/libc.utf8/.gitignore
 create mode 100644 src/test/default_collation/libc.utf8/Makefile
 create mode 100644 src/test/default_collation/libc.utf8/t/001_default_collation.pl
 create mode 100644 src/test/default_collation/libc/.gitignore
 create mode 100644 src/test/default_collation/libc/Makefile
 create mode 100644 src/test/default_collation/libc/t/001_default_collation.pl

diff --git a/doc/src/sgml/charset.sgml b/doc/src/sgml/charset.sgml
index a6143ef8a7..8a46d3d311 100644
--- a/doc/src/sgml/charset.sgml
+++ b/doc/src/sgml/charset.sgml
@@ -537,6 +537,61 @@ SELECT * FROM test1 ORDER BY a || b COLLATE "fr_FR";
     a database.
    </para>
 
+   <para>
+    You can specify the default collation provider with the <option>--locale</option>
+    and <option>--lc-collate</option> options of the <xref linkend="app-initdb"/> or
+    <xref linkend="app-createdb"/> commands, as follows:
+<programlisting>
+--locale=<replaceable>locale</replaceable>[@<replaceable>provider</replaceable>]
+--lc-collate=<replaceable>locale</replaceable>[@<replaceable>provider</replaceable>]
+</programlisting>
+    where <replaceable>provider</replaceable> can take the <literal>icu</literal>
+    or <literal>libc</literal> value, and <replaceable>locale</replaceable> is specified
+    in the <literal>libc</literal> format. You can only specify a single
+    locale provider after the <literal>@</literal> symbol.
+    The <literal>--lc-collate</literal> option overrides the
+    <literal>--locale</literal> setting, regardless of whether it specifies the
+    collation provider.
+   </para>
+
+   <para>
+    If you omit the collation provider options, <literal>libc</literal>
+    provider is used for <literal>C</literal> and <literal>POSIX</literal>
+    locales. For other locales, the default providers are:
+    <itemizedlist spacing="compact">
+     <listitem>
+      <para>
+       <literal>icu</literal> at the cluster level
+      </para>
+     </listitem>
+     <listitem>
+      <para>Default collation provider from the template database at
+      the database level
+      </para>
+     </listitem>
+    </itemizedlist>
+   </para>
+
+   <important>
+    <para>
+     You can only use the <literal>icu</literal> collation provider for locales that are
+     supported by <literal>libc</literal> in your operating system and satisfy all
+     restrictions applicable to <literal>icu</literal>.
+    </para>
+   </important>
+
+   <para>
+     When you connect to a database,
+     <productname>PostgreSQL</productname> checks that the selected collation
+     provider and the version of the default collation are supported.
+     You can find the default database collation and the collation provider
+     in <structname>pg_database.datcollate</structname>. For ICU collations, collation version is
+     also stored:
+    <programlisting>
+<replaceable>locale</replaceable>@<replaceable>provider</replaceable>[.<replaceable>version</replaceable>]
+</programlisting>
+   </para>
+
    <sect3>
     <title>Standard Collations</title>
 
diff --git a/doc/src/sgml/ref/create_database.sgml b/doc/src/sgml/ref/create_database.sgml
index b2c9e241c2..8b2e153651 100644
--- a/doc/src/sgml/ref/create_database.sgml
+++ b/doc/src/sgml/ref/create_database.sgml
@@ -25,7 +25,7 @@ CREATE DATABASE <replaceable class="parameter">name</replaceable>
     [ [ WITH ] [ OWNER [=] <replaceable class="parameter">user_name</replaceable> ]
            [ TEMPLATE [=] <replaceable class="parameter">template</replaceable> ]
            [ ENCODING [=] <replaceable class="parameter">encoding</replaceable> ]
-           [ LC_COLLATE [=] <replaceable class="parameter">lc_collate</replaceable> ]
+           [ LC_COLLATE [=] <replaceable class="parameter">lc_collate</replaceable>[@<replaceable class="parameter">provider</replaceable>] ]
            [ LC_CTYPE [=] <replaceable class="parameter">lc_ctype</replaceable> ]
            [ TABLESPACE [=] <replaceable class="parameter">tablespace_name</replaceable> ]
            [ ALLOW_CONNECTIONS [=] <replaceable class="parameter">allowconn</replaceable> ]
@@ -112,13 +112,17 @@ CREATE DATABASE <replaceable class="parameter">name</replaceable>
       </listitem>
      </varlistentry>
      <varlistentry>
-      <term><replaceable class="parameter">lc_collate</replaceable></term>
+      <term><replaceable class="parameter">lc_collate</replaceable>[@<replaceable class="parameter">provider</replaceable>]</term>
       <listitem>
        <para>
         Collation order (<literal>LC_COLLATE</literal>) to use in the new database.
         This affects the sort order applied to strings, e.g. in queries with
         ORDER BY, as well as the order used in indexes on text columns.
         The default is to use the collation order of the template database.
+        Optionally, you can specify the default collation provider after the
+        <literal>@</literal> symbol, as explained in
+        <xref linkend="collation-managing"/>. Supported values are <literal>icu</literal>
+        and <literal>libc</literal>.
         See below for additional restrictions.
        </para>
       </listitem>
diff --git a/doc/src/sgml/ref/createdb.sgml b/doc/src/sgml/ref/createdb.sgml
index 2658efeb1a..dbf87d31ec 100644
--- a/doc/src/sgml/ref/createdb.sgml
+++ b/doc/src/sgml/ref/createdb.sgml
@@ -121,22 +121,34 @@ PostgreSQL documentation
      </varlistentry>
 
      <varlistentry>
-      <term><option>-l <replaceable class="parameter">locale</replaceable></option></term>
-      <term><option>--locale=<replaceable class="parameter">locale</replaceable></option></term>
+      <term><option>-l <replaceable class="parameter">locale</replaceable>[@<replaceable>provider</replaceable>]</option></term>
+      <term><option>--locale=<replaceable class="parameter">locale</replaceable>[@<replaceable>provider</replaceable>]</option></term>
       <listitem>
        <para>
         Specifies the locale to be used in this database.  This is equivalent
         to specifying both <option>--lc-collate</option> and <option>--lc-ctype</option>.
        </para>
+
+       <para>
+        Optionally, you can specify the default collation provider after the
+        <literal>@</literal> symbol. Supported values are <literal>icu</literal>
+        and <literal>libc</literal>. For details, see <xref linkend="collation-managing"/>.
+       </para>
       </listitem>
      </varlistentry>
 
      <varlistentry>
-      <term><option>--lc-collate=<replaceable class="parameter">locale</replaceable></option></term>
+      <term><option>--lc-collate=<replaceable class="parameter">locale</replaceable>[@<replaceable>provider</replaceable>]</option></term>
       <listitem>
        <para>
         Specifies the LC_COLLATE setting to be used in this database.
        </para>
+
+       <para>
+        Optionally, you can specify the default collation provider after the
+        <literal>@</literal> symbol. Supported values are <literal>icu</literal>
+        and <literal>libc</literal>. For details, see <xref linkend="collation-managing"/>.
+       </para>
       </listitem>
      </varlistentry>
 
diff --git a/doc/src/sgml/ref/initdb.sgml b/doc/src/sgml/ref/initdb.sgml
index 4489b585c7..738e41bab4 100644
--- a/doc/src/sgml/ref/initdb.sgml
+++ b/doc/src/sgml/ref/initdb.sgml
@@ -222,7 +222,7 @@ PostgreSQL documentation
      </varlistentry>
 
      <varlistentry>
-      <term><option>--locale=<replaceable>locale</replaceable></option></term>
+      <term><option>--locale=<replaceable>locale</replaceable>[@<replaceable>provider</replaceable>]</option></term>
       <listitem>
        <para>
         Sets the default locale for the database cluster.  If this
@@ -230,11 +230,16 @@ PostgreSQL documentation
         environment that <command>initdb</command> runs in. Locale
         support is described in <xref linkend="locale"/>.
        </para>
+       <para>
+        Optionally, you can specify the default collation provider after the
+        <literal>@</literal> symbol. Supported values are <literal>icu</literal>
+        and <literal>libc</literal>. For details, see <xref linkend="collation-managing"/>.
+       </para>
       </listitem>
      </varlistentry>
 
      <varlistentry>
-      <term><option>--lc-collate=<replaceable>locale</replaceable></option></term>
+      <term><option>--lc-collate=<replaceable>locale</replaceable>[@<replaceable>provider</replaceable>]</option></term>
       <term><option>--lc-ctype=<replaceable>locale</replaceable></option></term>
       <term><option>--lc-messages=<replaceable>locale</replaceable></option></term>
       <term><option>--lc-monetary=<replaceable>locale</replaceable></option></term>
diff --git a/doc/src/sgml/regress.sgml b/doc/src/sgml/regress.sgml
index 673a8c2164..dbc527964b 100644
--- a/doc/src/sgml/regress.sgml
+++ b/doc/src/sgml/regress.sgml
@@ -327,6 +327,23 @@ make check EXTRA_TESTS='collate.icu.utf8 collate.linux.utf8' LANG=en_US.utf8
    </para>
   </sect2>
 
+  <sect2>
+   <title>Extra TAP Tests for Default Collations</title>
+
+   <para>
+    To test the default collations on Linux/glibc platforms,
+    you can run extra TAP tests, as follows:
+<screen>
+make -C src/test/default_collation check-utf8
+</screen>
+    These tests only succeed when run in a database that uses the UTF-8
+    encoding. As these tests are TAP-based, you can only run them if
+    <productname>PostgreSQL</productname> was configured with the
+    <option>--enable-tap-tests</option> option.
+    For details, see <xref linkend="regress-tap"/>.
+   </para>
+  </sect2>
+
   <sect2>
    <title>Testing Hot Standby</title>
 
diff --git a/src/backend/catalog/information_schema.sql b/src/backend/catalog/information_schema.sql
index f4e69f4a26..8d34006847 100644
--- a/src/backend/catalog/information_schema.sql
+++ b/src/backend/catalog/information_schema.sql
@@ -397,7 +397,7 @@ CREATE VIEW character_sets AS
            CAST(c.collname AS sql_identifier) AS default_collate_name
     FROM pg_database d
          LEFT JOIN (pg_collation c JOIN pg_namespace nc ON (c.collnamespace = nc.oid))
-             ON (datcollate = collcollate AND datctype = collctype)
+             ON (datcollate = (collcollate || '@libc') AND datctype = collctype)
     WHERE d.datname = current_database()
     ORDER BY char_length(c.collname) DESC, c.collname ASC -- prefer full/canonical name
     LIMIT 1;
diff --git a/src/backend/commands/collationcmds.c b/src/backend/commands/collationcmds.c
index 8fb51e8c3d..6846ebc586 100644
--- a/src/backend/commands/collationcmds.c
+++ b/src/backend/commands/collationcmds.c
@@ -27,6 +27,7 @@
 #include "commands/comment.h"
 #include "commands/dbcommands.h"
 #include "commands/defrem.h"
+#include "common/pg_collation_fn_common.h"
 #include "mb/pg_wchar.h"
 #include "miscadmin.h"
 #include "utils/builtins.h"
@@ -162,11 +163,8 @@ DefineCollation(ParseState *pstate, List *names, List *parameters, bool if_not_e
 
 	if (collproviderstr)
 	{
-		if (pg_strcasecmp(collproviderstr, "icu") == 0)
-			collprovider = COLLPROVIDER_ICU;
-		else if (pg_strcasecmp(collproviderstr, "libc") == 0)
-			collprovider = COLLPROVIDER_LIBC;
-		else
+		collprovider = get_collprovider(collproviderstr);
+		if (!is_valid_nondefault_collprovider(collprovider))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
 					 errmsg("unrecognized collation provider: %s",
@@ -192,7 +190,8 @@ DefineCollation(ParseState *pstate, List *names, List *parameters, bool if_not_e
 		else
 		{
 			collencoding = GetDatabaseEncoding();
-			check_encoding_locale_matches(collencoding, collcollate, collctype);
+			check_encoding_locale_matches(collencoding, collcollate, collctype,
+										  collprovider);
 		}
 	}
 
@@ -433,26 +432,6 @@ cmpaliases(const void *a, const void *b)
 
 
 #ifdef USE_ICU
-/*
- * Get the ICU language tag for a locale name.
- * The result is a palloc'd string.
- */
-static char *
-get_icu_language_tag(const char *localename)
-{
-	char		buf[ULOC_FULLNAME_CAPACITY];
-	UErrorCode	status;
-
-	status = U_ZERO_ERROR;
-	uloc_toLanguageTag(localename, buf, sizeof(buf), TRUE, &status);
-	if (U_FAILURE(status))
-		ereport(ERROR,
-				(errmsg("could not convert locale name \"%s\" to language tag: %s",
-						localename, u_errorName(status))));
-
-	return pstrdup(buf);
-}
-
 /*
  * Get a comment (specifically, the display name) for an ICU locale.
  * The result is a palloc'd string, or NULL if we can't get a comment
@@ -698,7 +677,7 @@ pg_import_system_collations(PG_FUNCTION_ARGS)
 				name = uloc_getAvailable(i);
 
 			langtag = get_icu_language_tag(name);
-			collcollate = U_ICU_VERSION_MAJOR_NUM >= 54 ? langtag : name;
+			collcollate = get_icu_collate(name, langtag);
 
 			/*
 			 * Be paranoid about not allowing any non-ASCII strings into
diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 5342f217c0..610fece468 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -34,6 +34,7 @@
 #include "catalog/indexing.h"
 #include "catalog/objectaccess.h"
 #include "catalog/pg_authid.h"
+#include "catalog/pg_collation.h"
 #include "catalog/pg_database.h"
 #include "catalog/pg_db_role_setting.h"
 #include "catalog/pg_subscription.h"
@@ -44,6 +45,7 @@
 #include "commands/defrem.h"
 #include "commands/seclabel.h"
 #include "commands/tablespace.h"
+#include "common/pg_collation_fn_common.h"
 #include "mb/pg_wchar.h"
 #include "miscadmin.h"
 #include "pgstat.h"
@@ -141,6 +143,14 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 	int			notherbackends;
 	int			npreparedxacts;
 	createdb_failure_params fparms;
+	char	   *src_canonname;
+	char		src_collprovider;
+	char	   *dbcanonname = NULL;
+	char		dbcollprovider;
+	char	   *dbcollate_full_name;
+	char	   *icu_wincollate = NULL;
+	char	   *langtag = NULL;
+	const char *collate;
 
 	/* Extract options from the statement node tree */
 	foreach(option, stmt->options)
@@ -350,8 +360,28 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 	/* If encoding or locales are defaulted, use source's setting */
 	if (encoding < 0)
 		encoding = src_encoding;
+
+	check_locale_collprovider(src_collate, &src_canonname, &src_collprovider,
+							  NULL);
+
+	if (!is_valid_nondefault_collprovider(src_collprovider))
+		/* This could happen when manually creating a mess in the catalogs. */
+		ereport(FATAL,
+				(errmsg("could not find out the collation provider for datcollate \"%s\" of template database \"%s\"",
+						src_collate, dbtemplate)));
+
 	if (dbcollate == NULL)
-		dbcollate = src_collate;
+	{
+		dbcollate = src_canonname;
+		dbcollprovider = src_collprovider;
+	}
+	else
+	{
+		check_locale_collprovider(dbcollate, &dbcanonname, &dbcollprovider,
+								  NULL);
+		dbcollate = dbcanonname;
+	}
+
 	if (dbctype == NULL)
 		dbctype = src_ctype;
 
@@ -362,18 +392,88 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 				 errmsg("invalid server encoding %d", encoding)));
 
 	/* Check that the chosen locales are valid, and get canonical spellings */
-	if (!check_locale(LC_COLLATE, dbcollate, &canonname))
-		ereport(ERROR,
-				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
-				 errmsg("invalid locale name: \"%s\"", dbcollate)));
-	dbcollate = canonname;
-	if (!check_locale(LC_CTYPE, dbctype, &canonname))
+
+	if (!check_locale(LC_CTYPE, dbctype, &canonname, '\0'))
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("invalid locale name: \"%s\"", dbctype)));
 	dbctype = canonname;
 
-	check_encoding_locale_matches(encoding, dbcollate, dbctype);
+	/* we always check lc_collate for libc */
+	if (!check_locale(LC_COLLATE, dbcollate, &canonname, COLLPROVIDER_LIBC))
+		ereport(ERROR,
+				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+				 errmsg("invalid locale name: \"%s\" (provider \"%s\")",
+						dbcollate, get_collprovider_name(COLLPROVIDER_LIBC))));
+	dbcollate = canonname;
+
+	/* determine the collation provider if we haven't already done it */
+	if (!is_valid_nondefault_collprovider(dbcollprovider))
+	{
+		if (locale_is_c(dbcollate))
+			dbcollprovider = COLLPROVIDER_LIBC;
+		else
+			dbcollprovider = src_collprovider;
+	}
+
+	Assert(is_valid_nondefault_collprovider(dbcollprovider));
+
+#ifndef USE_ICU
+	if (dbcollprovider == COLLPROVIDER_ICU)
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("ICU is not supported in this build"),
+				 errhint("You need to rebuild PostgreSQL using --with-icu.")));
+#endif
+
+	/* check lc_collate and lc_ctype for icu if we need it */
+	if (dbcollprovider == COLLPROVIDER_ICU)
+	{
+		if (!check_locale(LC_COLLATE, dbcollate, NULL, dbcollprovider))
+			ereport(ERROR,
+					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+					 errmsg("invalid locale name: \"%s\" (provider \"%s\")",
+							dbcollate, get_collprovider_name(dbcollprovider))));
+
+		if (strcmp(dbcollate, dbctype) != 0)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("collations with different collate and ctype values are not supported by ICU")));
+	}
+
+	check_encoding_locale_matches(encoding, dbcollate, dbctype, dbcollprovider);
+
+	/* get the collation version */
+
+#ifdef USE_ICU
+	if (dbcollprovider == COLLPROVIDER_ICU)
+	{
+		collate = (const char *) dbcollate;
+#ifdef WIN32
+		if (!locale_is_c(collate))
+		{
+			icu_wincollate = check_icu_winlocale(collate);
+			collate = (const char *) icu_wincollate;
+		}
+#endif							/* WIN32 */
+		langtag = get_icu_language_tag(collate);
+		collate = get_icu_collate(collate, langtag);
+	}
+	else
+#endif							/* USE_ICU */
+	{
+		/* COLLPROVIDER_LIBC */
+		collate = (const char *) dbcollate;
+	}
+
+	dbcollate_full_name = get_full_collation_name(
+						dbcollate, dbcollprovider,
+						get_collation_actual_version(dbcollprovider, collate));
+
+	if (strlen(dbcollate_full_name) >= NAMEDATALEN)
+		ereport(ERROR,
+				(errmsg("the full database collation name \"%s\" is too long",
+						dbcollate_full_name)));
 
 	/*
 	 * Check that the new encoding and locale settings match the source
@@ -395,11 +495,11 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 							pg_encoding_to_char(src_encoding)),
 					 errhint("Use the same encoding as in the template database, or use template0 as template.")));
 
-		if (strcmp(dbcollate, src_collate) != 0)
+		if (strcmp(dbcollate_full_name, src_collate) != 0)
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("new collation (%s) is incompatible with the collation of the template database (%s)",
-							dbcollate, src_collate),
+							dbcollate_full_name, src_collate),
 					 errhint("Use the same collation as in the template database, or use template0 as template.")));
 
 		if (strcmp(dbctype, src_ctype) != 0)
@@ -522,7 +622,7 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 	new_record[Anum_pg_database_datdba - 1] = ObjectIdGetDatum(datdba);
 	new_record[Anum_pg_database_encoding - 1] = Int32GetDatum(encoding);
 	new_record[Anum_pg_database_datcollate - 1] =
-		DirectFunctionCall1(namein, CStringGetDatum(dbcollate));
+		DirectFunctionCall1(namein, CStringGetDatum(dbcollate_full_name));
 	new_record[Anum_pg_database_datctype - 1] =
 		DirectFunctionCall1(namein, CStringGetDatum(dbctype));
 	new_record[Anum_pg_database_datistemplate - 1] = BoolGetDatum(dbistemplate);
@@ -690,6 +790,16 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 		 */
 		ForceSyncCommit();
 	}
+
+	pfree(src_canonname);
+	pfree(dbcollate_full_name);
+	if (dbcanonname)
+		pfree(dbcanonname);
+	if (langtag)
+		pfree(langtag);
+	if (icu_wincollate)
+		pfree(icu_wincollate);
+
 	PG_END_ENSURE_ERROR_CLEANUP(createdb_failure_callback,
 								PointerGetDatum(&fparms));
 
@@ -719,7 +829,8 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
  * Note: if you change this policy, fix initdb to match.
  */
 void
-check_encoding_locale_matches(int encoding, const char *collate, const char *ctype)
+check_encoding_locale_matches(int encoding, const char *collate, const char *ctype,
+							  char collprovider)
 {
 	int			ctype_encoding = pg_get_encoding_from_locale(ctype, true);
 	int			collate_encoding = pg_get_encoding_from_locale(collate, true);
@@ -753,6 +864,23 @@ check_encoding_locale_matches(int encoding, const char *collate, const char *cty
 						collate),
 				 errdetail("The chosen LC_COLLATE setting requires encoding \"%s\".",
 						   pg_encoding_to_char(collate_encoding))));
+
+	if (collprovider == COLLPROVIDER_ICU)
+	{
+#ifdef USE_ICU
+		if (!(is_encoding_supported_by_icu(encoding) ||
+			  (encoding == PG_SQL_ASCII && superuser())))
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					 errmsg("encoding \"%s\" is not supported for ICU locales",
+							pg_encoding_to_char(encoding))));
+#else
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("ICU is not supported in this build"),
+				 errhint("You need to rebuild PostgreSQL using --with-icu.")));
+#endif
+	}
 }
 
 /* Error cleanup callback for createdb */
diff --git a/src/backend/main/main.c b/src/backend/main/main.c
index 38853e38eb..cb27d626bd 100644
--- a/src/backend/main/main.c
+++ b/src/backend/main/main.c
@@ -32,6 +32,7 @@
 #endif
 
 #include "bootstrap/bootstrap.h"
+#include "catalog/pg_collation.h"
 #include "common/username.h"
 #include "port/atomics.h"
 #include "postmaster/postmaster.h"
@@ -306,8 +307,8 @@ startup_hacks(const char *progname)
 static void
 init_locale(const char *categoryname, int category, const char *locale)
 {
-	if (pg_perm_setlocale(category, locale) == NULL &&
-		pg_perm_setlocale(category, "C") == NULL)
+	if (pg_perm_setlocale(category, locale, COLLPROVIDER_LIBC) == NULL &&
+		pg_perm_setlocale(category, "C", COLLPROVIDER_LIBC) == NULL)
 		elog(FATAL, "could not adopt \"%s\" locale nor C locale for %s",
 			 locale, categoryname);
 }
diff --git a/src/backend/regex/regc_pg_locale.c b/src/backend/regex/regc_pg_locale.c
index acbed2eeed..e836553f64 100644
--- a/src/backend/regex/regc_pg_locale.c
+++ b/src/backend/regex/regc_pg_locale.c
@@ -16,6 +16,7 @@
  */
 
 #include "catalog/pg_collation.h"
+#include "common/pg_collation_fn_common.h"
 #include "utils/pg_locale.h"
 
 /*
@@ -240,8 +241,13 @@ pg_set_regex_collation(Oid collation)
 	}
 	else
 	{
+		char collprovider;
+
 		if (collation == DEFAULT_COLLATION_OID)
+		{
 			pg_regex_locale = 0;
+			collprovider = get_default_collprovider();
+		}
 		else if (OidIsValid(collation))
 		{
 			/*
@@ -250,6 +256,7 @@ pg_set_regex_collation(Oid collation)
 			 * have to be considered below.
 			 */
 			pg_regex_locale = pg_newlocale_from_collation(collation);
+			collprovider = pg_regex_locale->provider;
 		}
 		else
 		{
@@ -263,24 +270,35 @@ pg_set_regex_collation(Oid collation)
 					 errhint("Use the COLLATE clause to set the collation explicitly.")));
 		}
 
+		Assert(is_valid_nondefault_collprovider(collprovider));
+
+		if (collprovider == COLLPROVIDER_ICU)
+		{
 #ifdef USE_ICU
-		if (pg_regex_locale && pg_regex_locale->provider == COLLPROVIDER_ICU)
 			pg_regex_strategy = PG_REGEX_LOCALE_ICU;
-		else
+#else
+			/* shouldn't happen */
+			elog(ERROR, "unsupported collprovider: %c", collprovider);
 #endif
-		if (GetDatabaseEncoding() == PG_UTF8)
-		{
-			if (pg_regex_locale)
-				pg_regex_strategy = PG_REGEX_LOCALE_WIDE_L;
-			else
-				pg_regex_strategy = PG_REGEX_LOCALE_WIDE;
 		}
 		else
 		{
-			if (pg_regex_locale)
-				pg_regex_strategy = PG_REGEX_LOCALE_1BYTE_L;
+			/* COLLPROVIDER_LIBC */
+
+			if (GetDatabaseEncoding() == PG_UTF8)
+			{
+				if (pg_regex_locale)
+					pg_regex_strategy = PG_REGEX_LOCALE_WIDE_L;
+				else
+					pg_regex_strategy = PG_REGEX_LOCALE_WIDE;
+			}
 			else
-				pg_regex_strategy = PG_REGEX_LOCALE_1BYTE;
+			{
+				if (pg_regex_locale)
+					pg_regex_strategy = PG_REGEX_LOCALE_1BYTE_L;
+				else
+					pg_regex_strategy = PG_REGEX_LOCALE_1BYTE;
+			}
 		}
 
 		pg_regex_collation = collation;
